
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>
#include <ArduinoJson.h>

// Замените на свои сетевые данные
  const char* ssid = "XXXXXXXXXX";
  const char* password = "XXXXXXXXXXXX";

// Инициализация Telegram бота
#define BOTtoken "XXXXXXXXXXX:XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" // Ваш Токен
#define CHAT_ID "XXXXXXX"                                      // ID чата

WiFiClientSecure client;
UniversalTelegramBot bot(BOTtoken, client);

const int gasSensor = A0;                                       // Сенсор протечки
bool gasDetected = false;
int count = 3;                                                  // Количество сообщений
const int drop = 150;                                           // Капля

void setup() {
  Serial.begin(115200);
  client.setInsecure();
  
  pinMode(gasSensor, INPUT_PULLUP);                             // Внутренняя подтяжка сенсора  INPUT_PULLUP

  Serial.print("Соединение с Wifi: ");
  Serial.println(ssid);

  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }

  Serial.println("");
  Serial.println("WiFi соединение установлено");
  Serial.print("IP адрес: ");
  Serial.println(WiFi.localIP());

  bot.sendMessage(CHAT_ID, "Бот <Утечка ГАЗА> стартовал", "");
}

void loop() {
  int sensorValue = analogRead(gasSensor);                                                // Считываем значение с A0   
  if(gasDetected && count){
    bot.sendMessage(CHAT_ID, "Обнаружена Утечка ГАЗА!!!", "");
    Serial.println("Обнаружена Утечка ГАЗА");
    count -= 1;                                                                             // Уменьшаем счётчик на 1  
    delay(10000);                                                                           // Пауза 10 секунд  
     
  }
     
  if (sensorValue > drop) {
    gasDetected = true;                                                                   // Состояние датчика
  }
  else {
    gasDetected = false;                                                                  // Состояние датчика
    count = 3;                                                                              // Количество сообщений снова 3
  }
}
